
QGIS Application - Bug report #7924

QGIS Server: GetProjectSettings lists field type with QString instead of boolean

2013-05-28 07:05 AM - Andreas Neumann

Status: Closed

Priority: Normal

Assignee: Marco Hugentobler

Category: QGIS Server

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: fixed/implemented

Crashes QGIS or corrupts data:No Copied to github as #: 16795

Description

I sometimes use boolean data types represented with checkboxes. In QWC (QGIS web client) I want to display them with yes/no instead

of "t" and "f". I need to therefore detect these boolean values.

In the output of the GetProjectSettings reponse I get the type as QString. I cannot use the edit type, because in this setup the edit type is

set to "Hidden". I want to hide them in QGIS desktop but show them in QGIS Web Client.

So, is there a chance that the boolean values (set to boolean in Postgis) would be reported as boolean and not as a QString?

example output of GetProjectSettings:

&lt;Attributes&gt;

       &lt;Attribute precision="0" length="-1" editType="Immutable" type="int" comment="" name="GID (Punktelement)"/&gt;

       &lt;Attribute precision="0" length="-1" editType="ValueRelation" type="int" comment="" name="GID Baustellenprojekt"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Projekt-Nr Uster"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Objekt- oder

Projektbezeichnung"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Perimeter"/&gt;

       &lt;Attribute precision="0" length="-1" editType="Hidden" type="QString" comment="" name="Bauherr"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Planungs- oder

Ingenieurbüro"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Ansprechsperson Planungs-

oder Ingenieurbüro"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Tel-Nr. Ansprechsperson

Planungs- oder Ingenieurbüro"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Projektleiter Stadt Uster"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Projektleiter Energie Uster

AG"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Projektleiter Kanton

Zürich"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Tempo 30 Zone"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Vorhandenes

Planungskonzept"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Betriebs- und

Gestaltungskonzept"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Betroffen Strasse"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Betroffen öffentlicher

Kanal"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Betroffen

Liegenschaftsentwässerung"/&gt;
       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Betroffen Gas"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Betroffen Wasser"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Betroffen Elektro"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Betroffen öffentliche

Beleuchtung"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Betroffen Swisscom"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Betroffen Cablecom"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QDate" comment="" name="Start Bauprojekt"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QDate" comment="" name="Start Koordination Werke"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QDate" comment="" name="Start Submission"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QDate" comment="" name="Baubeginn"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QDate" comment="" name="Bauende"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Ausführungsjahr"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Hidden" type="QString" comment="" name="Bemerkung"/&gt;

       &lt;Attribute precision="-1" length="-1" editType="Immutable" type="QString" comment="" name="tooltip"/&gt;

      &lt;/Attributes&gt;

in the above example all of the "Betroffen_xxx" attributes are actually of type boolean, but are reported as "QString".

History

#1 - 2013-05-28 07:17 AM - Andreas Neumann

Alternatively it would be useful to have an additional column in the fields tab called "Desktop" that separates the "Hidden" from the widget choice.

This would be even more flexible and elegant.

#2 - 2014-06-30 06:17 AM - Andreas Neumann

- Resolution set to fixed/implemented

- Status changed from Open to Closed

This was already implemented in QGIS server a while ago.
